#property copyright "http://dmffx.com"
#property link      "http://dmffx.com"

#property indicator_separate_window
#property indicator_minimum -1
#property indicator_maximum 1
#property indicator_buffers 3
#property indicator_color1 Red
#property indicator_color2 Yellow
#property indicator_color3 Blue

#property indicator_width1 5
#property indicator_width2 3
#property indicator_width3 1

//---- input parameters



extern string  Symbol_1          =  "EURUSD";   //  1
extern string  Symbol_2          =  "GBPUSD";   //  2   
extern int     TimeFrame         =  0;          // 
extern int     PCPeriod          =  14;         // 
extern int     PCPrice           =  0;          // : 0-Close, 1-Open, 2-High, 3-Low, 4-Median, 5-Typical, 6-Weighted
extern double  Level             =  0.7;        //  

//---- buffers
double ExtMapBuffer1[];
double ExtMapBuffer2[];
double ExtMapBuffer3[];


//+------------------------------------------------------------------+
//| Custom indicator initialization function                         |
//+------------------------------------------------------------------+
int init() {
   


   if(StringTrimLeft(StringTrimRight(Symbol_1))=="")Symbol_1=Symbol();
   if(StringTrimLeft(StringTrimRight(Symbol_2))=="")Symbol_2=Symbol();
   if(TimeFrame==0)TimeFrame=Period();

//---- indicators
   SetIndexStyle(0,DRAW_LINE);
   SetIndexBuffer(0,ExtMapBuffer1);
   
   SetIndexStyle(1,DRAW_LINE);
   SetIndexBuffer(1,ExtMapBuffer2); 
   
   SetIndexStyle(2,DRAW_LINE);
   SetIndexBuffer(2,ExtMapBuffer3);
   

   
   SetIndexLabel(0,"");
   SetIndexLabel(1,"1/x");   
   SetIndexLabel(2,"-x");    
   
   IndicatorDigits(2);
   
   SetLevelValue(0,Level);
   SetLevelValue(1,-Level);
//----
   return(0);
  }
//+------------------------------------------------------------------+
//| Custom indicator deinitialization function                       |
//+------------------------------------------------------------------+
int deinit()
  {

   return(0);
  }
//+------------------------------------------------------------------+
//| Custom indicator iteration function                              |
//+------------------------------------------------------------------+
int start(){
   Ind_PirsonPricePrice_TFS(Symbol_1,Symbol_2,TimeFrame,ExtMapBuffer1,PCPeriod,PCPrice); 
   return(0);
}
//+------------------------------------------------------------------+


void Ind_PirsonPricePrice_TFS(string aSymbol_1,string aSymbol_2, int aTimeFrame,double & aToBuf[],int aPeriod,int aPrice){
   static bool err;
      if(!LibCOR_fDataUpdate(aSymbol_1,aTimeFrame,3) || !LibCOR_fDataUpdate(aSymbol_2,aTimeFrame,3)){
         Comment("   "+aSymbol_1+", "+aSymbol_2+" "+fTimeFrameName(aTimeFrame));
         err=true;
         return(0);
      }
   int limit=Bars-IndicatorCounted()-1;
      if(err){
         err=false;
         limit=Bars-1;
         Comment("");
      }
	int NTFBarNum_1=iBarShift(aSymbol_1,aTimeFrame,Time[limit],true);
	datetime NTFTime_1=iTime(aSymbol_1,aTimeFrame,NTFBarNum_1);
	int NTFBarNum_2=iBarShift(aSymbol_2,aTimeFrame,Time[limit],true);
	datetime NTFTime_2=iTime(aSymbol_1,aTimeFrame,NTFBarNum_2);	
	limit=iBarShift(NULL,0,MathMax(NTFTime_1,NTFTime_2));	
	     for(int i=limit;i>=0;i--){
            int BarNum_1=iBarShift(aSymbol_1,aTimeFrame,Time[i],false); 
            int BarNum_2=iBarShift(aSymbol_2,aTimeFrame,Time[i],false); 
            double tValue;
               if(fPirsonPricePrice_TFS(aSymbol_1,BarNum_1,aSymbol_2,BarNum_2,aTimeFrame,aPeriod,aPrice,tValue)){
                  aToBuf[i]=-tValue;
               }
               else{
                  aToBuf[i]=aToBuf[i+1];
               }
               if(fPirsonPricePrice_TFS_x_1(aSymbol_1,BarNum_1,aSymbol_2,BarNum_2,aTimeFrame,aPeriod,aPrice,tValue)){
                  ExtMapBuffer2[i]=tValue;
               }
               else{
                  ExtMapBuffer2[i]=aToBuf[i+1];
               }   
               if(fPirsonPricePrice_TFS_x_2(aSymbol_1,BarNum_1,aSymbol_2,BarNum_2,aTimeFrame,aPeriod,aPrice,tValue)){
                  ExtMapBuffer3[i]=tValue;
               }
               else{
                  ExtMapBuffer3[i]=aToBuf[i+1];
               }                              
      }
}
bool fPirsonPricePrice_TFS(string aSymbol_1,int aShift_1,string aSymbol_2,int aShift_2,int aTimeFrame,int aPeriod, int aPrice, double & aCorrelation){
   double SumXY=0;
   double SumXX=0;
   double SumYY=0;
   double SumY=0;
   double SumX=0;         
   int j;
   int xi;
   int yi;
      for(j=0,xi=aShift_1,yi=aShift_2;j<aPeriod;j++,xi++,yi++){
         double X=iMA(aSymbol_1,aTimeFrame,1,0,0,aPrice,xi);
         double Y=iMA(aSymbol_2,aTimeFrame,1,0,0,aPrice,yi);
         SumX+=X;  
         SumY+=Y;  
         SumXX+=X*X;
         SumYY+=Y*Y;         
         SumXY+=X*Y; 
      }
   double SXY=aPeriod*SumXY-SumY*SumX; 
   double SXXYY=MathSqrt(MathAbs((aPeriod*SumXX-SumX*SumX)*(aPeriod*SumYY-SumY*SumY)));
      if(SXXYY!=0.0){
         aCorrelation=SXY/SXXYY;
         return(true);
      }  
   return(false);
}

bool fPirsonPricePrice_TFS_x_1(string aSymbol_1,int aShift_1,string aSymbol_2,int aShift_2,int aTimeFrame,int aPeriod, int aPrice, double & aCorrelation){
   double SumXY=0;
   double SumXX=0;
   double SumYY=0;
   double SumY=0;
   double SumX=0;         
   int j;
   int xi;
   int yi;
      for(j=0,xi=aShift_1,yi=aShift_2;j<aPeriod;j++,xi++,yi++){
         double X=iMA(aSymbol_1,aTimeFrame,1,0,0,aPrice,xi);
         if(X!=0)X=1.0/X;
         double Y=iMA(aSymbol_2,aTimeFrame,1,0,0,aPrice,yi);
         SumX+=X;  
         SumY+=Y;  
         SumXX+=X*X;
         SumYY+=Y*Y;         
         SumXY+=X*Y; 
      }
   double SXY=aPeriod*SumXY-SumY*SumX; 
   double SXXYY=MathSqrt(MathAbs((aPeriod*SumXX-SumX*SumX)*(aPeriod*SumYY-SumY*SumY)));
      if(SXXYY!=0.0){
         aCorrelation=SXY/SXXYY;
         return(true);
      }  
}

bool fPirsonPricePrice_TFS_x_2(string aSymbol_1,int aShift_1,string aSymbol_2,int aShift_2,int aTimeFrame,int aPeriod, int aPrice, double & aCorrelation){
   double SumXY=0;
   double SumXX=0;
   double SumYY=0;
   double SumY=0;
   double SumX=0;         
   int j;
   int xi;
   int yi;
      for(j=0,xi=aShift_1,yi=aShift_2;j<aPeriod;j++,xi++,yi++){
         double X=-iMA(aSymbol_1,aTimeFrame,1,0,0,aPrice,xi);
         double Y=iMA(aSymbol_2,aTimeFrame,1,0,0,aPrice,yi);
         SumX+=X;  
         SumY+=Y;  
         SumXX+=X*X;
         SumYY+=Y*Y;         
         SumXY+=X*Y; 
      }
   double SXY=aPeriod*SumXY-SumY*SumX; 
   double SXXYY=MathSqrt(MathAbs((aPeriod*SumXX-SumX*SumX)*(aPeriod*SumYY-SumY*SumY)));
      if(SXXYY!=0.0){
         aCorrelation=SXY/SXXYY;
         return(true);
      }  
}

bool LibCOR_fDataUpdate(string aSymbol,int aTimeFrame,int aMinBars=300){
   datetime daytimes[];
      if(iClose(aSymbol,aTimeFrame,0)==0){
         return(false);
      }
   ArrayCopySeries(daytimes,MODE_TIME,aSymbol,aTimeFrame);
      if(GetLastError()==4066){
         return(false);
      }
      if(iBars(aSymbol,aTimeFrame)<aMinBars){
         return(false);
      }
   return(true);      
}

string fTimeFrameName(int arg){
      if(arg==0){
         arg=Period();
      }
      switch(arg){
         case 0:
            return("0");
         case 1:
            return("M1");
         case 5:
            return("M5");                  
         case 15:
            return("M15");
         case 30:
            return("M30");             
         case 60:
            return("H1");
         case 240:
            return("H4");                  
         case 1440:
            return("D1");
         case 10080:
            return("W1");          
         case 43200:
            return("MN1");
         default:
            return("M"+arg);          
      }
}

